/* credit for the interface to add/del/mod whitelist entries goes to Ben Basson (cusser), the creator of disable targets for downloads
 * pref-disabletarget.js
 *
 * most of this code was borrowed from the XPI Whitelist Manager extension,
 * and was contributed by Shelumi'El Jordan, S.D.G. (MonkeeSage)
 *
 */
var gPref = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
var list, entry;


function export_data() {
  // thanks to adblock
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
  var stream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
  
  
  fp.init(window, document.getElementById("redirremlocale").getString("selectfile"), fp.modeSave);
  fp.appendFilters(fp.filterText);
  
  if (fp.show() != fp.returnCancel) {
    dosave();
    if (fp.file.exists()) fp.file.remove(true);
		fp.file.create(fp.file.NORMAL_FILE_TYPE, 0666);

		stream.init(fp.file, 0x02, 0x200, null);
    //stream.write("redirremminver=0.3\n", 19);
    
    var patterns = new Array(
      "redirremminver=1\n", // write min version (only needed for syntaxcheck)
      "active="+gPref.getBoolPref("extensions.redirrem.active",false)+"\n",
      "whitelist="+gPref.getCharPref("extensions.redirrem.whitelist",false)+"\n"
   );
   	
      
    for (var i = 0; i < patterns.length ; i++) {
			stream.write(patterns[i], patterns[i].length);
		}
   
		stream.close();
	}
}

function import_data() {
  // thanks to adblock
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
	var stream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
	var streamIO = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
  var appendfilters=true;
  
  fp.init(window, document.getElementById("redirremlocale").getString("selectfile"), fp.modeOpen);
	fp.appendFilters(fp.filterText);

	if (fp.show() != fp.returnCancel) {
    dosave();
		stream.init(fp.file, 0x01, 0444, null);
		streamIO.init(stream);
    input = streamIO.read(stream.available());
		streamIO.close();
		stream.close();
		

		linebreak = input.match(/(((\n+)|(\r+))+)/m)[1]; // first: whole match -- second: backref-1 -- etc..
		loadedvars = input.split(linebreak);
    
    var exportvernr=loadedvars[0].split("=",2)[1];

    if(parseFloat(exportvernr)!=(exportvernr*1) || loadedvars[0].split("=",2)[0]!="redirremminver") {
      alert(document.getElementById("redirremlocale").getString("importfailed_wrong")); 
    } else if(exportvernr > 1) {
      alert(document.getElementById("redirremlocale").getString("importfailed_greater"));      
    } else if(exportvernr< 1) {
      alert(document.getElementById("redirremlocale").getString("importfailed_lesser"));
    } else {      
      for(var y=1;y<loadedvars.length;++y) {
        var key=loadedvars[y].split("=",2)[0];
        var val=loadedvars[y].split("=",2)[1];
        if(key=="active" && val=="true") gPref.setBoolPref("extensions.redirrem.active", true);
				if(key=="active" && val=="false") gPref.setBoolPref("extensions.redirrem.active", false);
        if(key=="whitelist") {       
         if(confirm(document.getElementById("redirremlocale").getString("import_appendoverwrite"))) 
           gPref.setCharPref("extensions.redirrem.whitelist", val.trim());
         else {
           var value=gPref.getCharPref("extensions.redirrem.whitelist");
           var valuelist=value.split(" ");
           var newvaluelist=val.split(" ");
           
           for(i=0; i<newvaluelist.length;++i) {
             append=true;
             for(z=0;z<valuelist.length;++z) {
               if(valuelist[z]==newvaluelist[i]) {
                 append=false;
                 break;
               }
             }
             if(append) value=value+" "+newvaluelist[i];
           }  
           gPref.setCharPref("extensions.redirrem.whitelist", value.trim());
         }  
         var delitems = list.childNodes, i;
         for (i = 0; i < delitems.length; ++i) {
           list.removeChild(delitems[i]);
         }
        }
      }
      DTFD_EMInit();
    }    
	}
}


String.prototype.trim = function() {
   return this.replace(/^\s+|\s+$/g, '');
}

String.prototype.cat = function(data, chr) {
   return this + data + chr;
}

function DTFD_EMInit() {

   document.getElementById("active").checked=nsPreferences.getBoolPref("extensions.redirrem.active",false);
   var data, items, item;
   // set these once and refer to them later
   list = document.getElementById('extensionlist');
   entry = document.getElementById('extensionEntry');

   try {     
      data = gPref.getCharPref("extensions.redirrem.whitelist");
   }
   catch (e) {}
   
   if (!data.length) return true;

   items = data.split(' ');
   for (var i = 0; i < items.length; ++i) {
      item = items[i].trim();
      list.appendItem(item, item.toLowerCase());
   }
   //list.selectedIndex = 0;
	 //list.selectedItem=list.childNodes[0];
   //entry.value=list.childNodes[0].value;
   return true;
}

function dosave() {
   nsPreferences.setBoolPref("extensions.redirrem.active",document.getElementById("active").checked);
   
   var string = new String(), item;

   for (var i = 0; i < list.getRowCount(); ++i) {
      item = list.getItemAtIndex(i).label;
      if (i < list.getRowCount() - 1) {
         string = string.cat(item, ' ');
      }
      else {
         string = string.cat(item, '');
      }
   }

   try {
      gPref.setCharPref("extensions.redirrem.whitelist", string);
   }
   catch (e) {}
}


function DTFD_Select() {   
   entry.value = list.selectedItem.label;
}

function DTFD_Add() { 
   if (!entry.value) return false;
   
   var items = list.childNodes, i;
   for (i = 0; i < items.length; ++i) {
        if (items[i].value == entry.value) {
           list.selectItem(items[i]);
           return true;
        }
   }
   
   list.selectedItem = list.appendItem(entry.value, entry.value.toLowerCase());
   entry.value = null;
   return true;
}

function DTFD_Mod() { 
   if (!entry.value) return false;
   
   var selectedIndex = list.getIndexOfItem(list.selectedItem);
   
   if (!list.selectedItem) return DTFD_Add();

   list.selectedItem.label = entry.value;
   list.selectedItem.value = entry.value.toLowerCase();
   return true; 
}

function DTFD_Del() { 
    var items = list.childNodes, i;
    for (i = 0; i < items.length; ++i) {
         if (items[i].hasAttribute('selected')) {
            list.removeChild(items[i]);
            // next few lines select a new item... tons better than having to reselect a new one. Deleting the whole lsit isn't pain anymore wee ^^
            if(i-1<0) i=0; else i=i-1;
            list.selectedItem=list.childNodes[i];
            entry.value=list.childNodes[i].label;
            break;
         }
    } 
    return true;
}